// Video Slice - Adobe Photoshop Script
// Description: Script per creare Video Slice
// Requirements: Adobe Photoshop CS, or higher
// Version: 2.1 14 Aprile 2015
// Author: Mauro Cappellin 
// Website: http://www.ciemmesoft.com/
// Copyright by Ciemmesoft
// ============================================================================
// Installation:
// 1. Place script in 'C:\Program Files\Adobe\Adobe Photoshop CS#\Presets\Scripts\'
// 2. Restart Photoshop
// 3. Choose File > Scripts > Video Slice 1_0.jsx
// ============================================================================

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////





var PathFoto = "C:\\"
var DimXFoto= 1920;
var DimYFoto= 1080;
var nstep = 10 ;
var nfotodisponibili = 400;
var nfotodasaltare = 1;

var fototot = Math.floor((nfotodisponibili-nstep) / nfotodasaltare);
	
var Tipologia=1;
var Risultato=1;
var Specchio=false;
var Margine=false


var QualitaJpeg = 10;

var dlg=
"dialog{text:'Video Slice - Copyright 2015 - Mamo -',bounds:[100,100,700,440],"+
"panel1:Panel{bounds:[10,10,590,330] , text:'' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+
"statictext1:StaticText{bounds:[10,10,311,27] , text:'Immagini da elaborare:' ,properties:{scrolling:undefined,multiline:undefined}},"+
"Folder1:EditText{bounds:[10,30,500,50] , text:'' ,properties:{multiline:false,noecho:false,readonly:false}},"+
"Browse1:IconButton{bounds:[510,30,551,67] , icon:'SourceFolderIcon',properties:{style:'toolbutton'}},"+
"statictext11:StaticText{bounds:[10,60,510,107], text:'Attenzione: Le foto devono essere nominate xxxxxx#####.est, dove xxxxx pu essere qualsiasi testo, #### un numero sequenziale di 4 cifre (eventuali zero e deve iniziare dal numero 1)', properties:{scrolling:false,multiline:true}}, "+
"statictext2:StaticText{bounds:[10,120,210,137], text:'Numero di Slice:', properties:{scrolling:false,multiline:false}}, "+
"eNStep:EditText{bounds:[220,120,295,137], text:'" + nstep + "', properties:{multiline:false,noecho:false,readonly:false}}, "+
"statictext3:StaticText{bounds:[10,140,210,157], text:'Numero di Foto disponibili:', properties:{scrolling:false,multiline:true}}, "+
"eNfotodisponibili:EditText{bounds:[220,140,295,157], text:'" + nfotodisponibili + "', properties:{multiline:false,noecho:false,readonly:false}}, "+
"statictext4:StaticText{bounds:[10,160,210,177], text:'Numero di frame da saltare:', properties:{scrolling:false,multiline:true}}, "+
"eNfotodasaltare:EditText{bounds:[220,160,295,177], text:'" + nfotodasaltare + "', properties:{multiline:false,noecho:false,readonly:false}}, "+

"statictext5:StaticText{bounds:[10,180,210,197], text:'Frames che verranno creati:', properties:{scrolling:false,multiline:true}}, "+
"statictext6:StaticText{bounds:[220,180,295,197], text:'" + fototot +"', properties:{scrolling:false,multiline:true}}, "+
"checkbox0:Checkbox{bounds:[10,200,260,217] , text:'Speculare' }, "+
"checkbox1:Checkbox{bounds:[10,220,260,237] , text:'Togliere margine tra gli slice' }, "+

"statictext7:StaticText{bounds:[10,240,90,257] , text:'Elaborazione' ,properties:{scrolling:undefined,multiline:undefined}},"+
"eModo:DropDownList{bounds:[91,240,551,257],properties:{items:["+
"'1=Rettangoli Verticali',"+
"'2=Rettangoli Orizzontali',"+
"'3=Spicchi',"+
"'4=Ventaglio',"+
"'5=Curve Verticali',"+
"'6=Curve Orizzontali',"+
"'7=Ellissi Verticali',"+
"'8=Ellissi Orizzontali'"+
"]}},"+

"statictext8:StaticText{bounds:[10,260,90,277] , text:'Risultato:' ,properties:{scrolling:undefined,multiline:undefined}},"+
"eModo2:DropDownList{bounds:[91,260,551,277],properties:{items:["+
"'1=Fotografia',"+
"'2=Video',"+
"'3=Composizione Video'"+
"]}}},"+


"Process:Button{bounds:[20,300,270,317] , text:'Ok' },"+
"button3:Button{bounds:[330,300,580,317] , text:'Cancel' }};"


var win = new Window(dlg,'Video Slice 2.1 del 13 Aprile 2015 - Copyright 2015 - Mamo -');
win.center();

win.Process.enabled=false;

win.panel1.eNStep.onChange = function() {
	var a= win.panel1.eNStep.text;
	var b= win.panel1.eNfotodisponibili.text;
	var c= win.panel1.eNfotodasaltare.text;
	var d= Math.floor((b-a) / c);
	win.panel1.statictext6.text = d;
}



win.panel1.eNfotodisponibili.onChange = function() {
	var a= win.panel1.eNStep.text;
	var b= win.panel1.eNfotodisponibili.text;
	var c= win.panel1.eNfotodasaltare.text;
	var d= Math.floor((b-a) / c);
	win.panel1.statictext6.text = d;
}

win.panel1.eNfotodasaltare.onChange = function() {
	var a= win.panel1.eNStep.text;
	var b= win.panel1.eNfotodisponibili.text;
	var c= win.panel1.eNfotodasaltare.text;
	var d= Math.floor((b-a) / c);
	win.panel1.statictext6.text = d;
}


win.panel1.Browse1.onClick = function() {
	inputFile = File(openDialog()); 
    if(inputFile !=null){
      win.panel1.Folder1.text =  decodeURI(inputFile.fsName); 
	  var eModo1 = parseInt(win.panel1.eModo.selection.index)+1;
	  if (eModo1!=null)
	  {
		var eModo3 = parseInt(win.panel1.eModo2.selection.index)+1;
		if (eModo3!=null)
		{
			win.Process.enabled=true;
		}
	  }
    }
	
	
	
}

win.panel1.eModo.onChange = function() {
	  var eModo1 = parseInt(win.panel1.eModo.selection.index)+1;
	  if (eModo1!=null)
	  {
		var eModo3 = parseInt(win.panel1.eModo2.selection.index)+1;
		if (eModo3!=null)
		{
			if (win.panel1.Folder1.text!="")
			{
				win.Process.enabled=true;
			}
		}
	  }
}

win.panel1.eModo2.onChange = function() {
	  var eModo1 = parseInt(win.panel1.eModo.selection.index)+1;
	  if (eModo1!=null)
	  {
		var eModo3 = parseInt(win.panel1.eModo2.selection.index)+1;
		if (eModo3!=null)
		{
			if (win.panel1.Folder1.text!="")
			{
				win.Process.enabled=true;
			}
		}
	  }
}

var done = false; 
    while (!done) { 
      var x = win.show(); 
      if (x == 0 || x == 2) {
        win.canceled = true;
        done = true; 
      } else if (x == 1) { 
        done = true; 
        {
       ProcessFiles();       
      } 
   }
  }

function ProcessFiles(){
//recupero le variabili
var FotoOriginale = "C:\\";
FotoOriginale = win.panel1.Folder1.text;

nstep  = win.panel1.eNStep.text;
nfotodisponibili = win.panel1.eNfotodisponibili.text;
nfotodasaltare = win.panel1.eNfotodasaltare.text;
Tipologia = parseInt(win.panel1.eModo.selection.index)+1;
Risultato = parseInt(win.panel1.eModo2.selection.index)+1;
var NumeroDiCicli= Math.floor((nfotodisponibili -nstep) / nfotodasaltare);
Specchio = win.panel1.checkbox0.value;
Margine = win.panel1.checkbox1.value;


var PosizionePunto=0;
var Ricerca="";
var DirectoryOriginale="";
var DirectoryFotoElaborate="";
var FotoDaElaborare = FotoOriginale;
var FotoElaborata ="";
var RadiceNome="";
var Continua=true;
var nfoto=0;


PosizionePunto=(FotoOriginale).indexOf("."); 
var Estensione=(FotoOriginale).substr(PosizionePunto+1,5); 

//ricerco il nome della directory che contiene le foto	
for (var Count = PosizionePunto; Count >=0; Count--)
{
	Ricerca=(FotoOriginale).substr(Count,1); 
	if (Ricerca=="\\")
	{
		DirectoryOriginale = (FotoOriginale).substr(0,Count); 
		DirectoryFotoElaborate = DirectoryOriginale + "\\VideoSlice";
		RadiceNome=(FotoOriginale).substr(Count+1,PosizionePunto-Count-6); 
		Count=0;
	}
}
//creo la sottodirectory dove memorizzare le foto elaborate
var folder1 = Folder(DirectoryFotoElaborate);
//Check if it exist, if not create it.
if(!folder1.exists) folder1.create();



//apro la prima immagine per recuperare un po' di informazioni e poi la chiudo
var fileRef = new File(FotoOriginale);
var docRef = app.open (fileRef);			
var originalRulerUnits = preferences.rulerUnits;
preferences.rulerUnits = Units.PIXELS;
preferences.typeUnits = TypeUnits.POINTS;
var AD = activeDocument;
var DocActiveLayer = AD.activeLayer; // Get target active layer
DimXFoto = AD.width.value;
DimYFoto = AD.height.value;	
AD.close(SaveOptions.DONOTSAVECHANGES);
var blending=true;





// FotoOriginaleCopia = FotoOriginale + "Copia.psd";
// ValoreZoom= win.panel1.eValoreZoom.text; 
// NumeroFoto = win.panel1.eNumeroFoto.text; 
// DurataScia = win.panel1.eDurataScia.text;
// Modo = parseInt(win.panel1.eModo.selection.index)+1;
	  


var ciclo1=0;	  
var ciclo2=0;	  
var Continua2=true;
var deltaX1=0;
var deltaX2=0;
var deltaY1=0;
var deltaY2=0;
var inizio=0;
var fare=false;
var numeroframe=1;
var salva=false;


// ============================================================================================================
		// Reset Vars Used and create some alias to make things easier for this hacker
		// ============================================================================================================ */
		// vars	for shape
		var rectangle	="Rctn";
		var ellipse	="Elps";
		// vars	for type
		var diminish	="diminish";
		var subtract	="diminish";
		var extend	="extend";
		var add		="add";
		var intersect	="intersect";
		var replace	="replace";
		/* ============================================================================================================
		// end vars and Aliases
		// ============================================================================================================ */


		var width	= 1920;
		var height	= 1080;
		var center	= true;
		var border	= false;	
		var shape	= ellipse;		
		var type	= replace;
		var feather	= 0;
		var antiAlias	= false;



while(Continua)	  
{
	ciclo1 =ciclo1 + 1;
	if (ciclo1> NumeroDiCicli) 
	{
		Continua = false;
	}
	else
	{
		Continua2=true;
		ciclo2=0;	  
		deltaX = 0;
		while (Continua2)
		{
			ciclo2 =ciclo2 + 1;
			nfoto = ciclo1 + Math.floor(((nfotodisponibili-NumeroDiCicli)/(nstep-1))*(ciclo2-1));
			
			if (ciclo2==1)//prima foto pertanto creo documento vuoto
			{
				//Create a new document with the correct dimensions and a transparent background
				FotoElaborata = "Frame " + numeroframe ; 
				var myNewDoc = app.documents.add(DimXFoto,DimYFoto,72,FotoElaborata, NewDocumentMode.RGB,DocumentFill.TRANSPARENT);
			}
			//creo il nome del file da aprire
			FotoDaElaborare = (FotoOriginale).substr(0, PosizionePunto - 4); 
			if (nfoto<10) FotoDaElaborare = FotoDaElaborare + "0"; 
			if (nfoto<100) FotoDaElaborare = FotoDaElaborare + "0"; 
			if (nfoto<1000) FotoDaElaborare = FotoDaElaborare + "0"; 
			FotoDaElaborare = FotoDaElaborare + nfoto + "." + Estensione; 
			//apro il file
			fileRef = new File(FotoDaElaborare);
			if(fileRef.exists)
			{
				docRef = app.open (fileRef);
				AD = activeDocument;
			}
			if (ciclo2==1 && Risultato!=3)//prima foto di foto o video
			{
				AD.selection.selectAll();
				AD.selection.copy();
				AD.close(SaveOptions.DONOTSAVECHANGES);
				//faccio il paste nella stessa posizione
				var idpast = charIDToTypeID( "past" );
				var desc557 = new ActionDescriptor();
				var idinPlace = stringIDToTypeID( "inPlace" );
				desc557.putBoolean( idinPlace, true );
				var idAntA = charIDToTypeID( "AntA" );
				var idAnnt = charIDToTypeID( "Annt" );
				var idAnno = charIDToTypeID( "Anno" );
				desc557.putEnumerated( idAntA, idAnnt, idAnno );
				executeAction( idpast, desc557, DialogModes.NO );
				//fine faccio il paste nella stessa posizione
				if(fileRef.exists)
				{
					docRef = app.open (fileRef);
					AD = activeDocument;
				}
			}
			// seleziono l'area da dove copiare
			AD.selection.selectAll();
			//creo una regione fittizzia
			var selRegion = Array(Array(0,0),
										Array(DimXFoto, 0),
										Array(DimXFoto, DimYFoto),
										Array(0,DimYFoto),
										Array(0, 0))

			if (Tipologia==1 )//semplice rettangoli verticali
			{
				if (Specchio)
				{
					deltaX1 = (nstep - (ciclo2 - 1)) * DimXFoto / nstep; 
					deltaX2 = (nstep - ciclo2) * DimXFoto / nstep -1; 
				}
				else
				{
					deltaX1 = (ciclo2 - 1) * DimXFoto / nstep; 
					deltaX2 = (ciclo2) * DimXFoto / nstep -1; 
				}
				if (Margine) 
				{	
					deltaX2 = deltaX2 + 1;
				}
				selRegion = Array(Array(deltaX1,0),
										Array(deltaX2, 0),
										Array(deltaX2, DimYFoto),
										Array(deltaX1,DimYFoto),
										Array(deltaX1, 0))
			}
			if (Tipologia==2)//semplice rettangoli orizzontali
			{
				if (Specchio)
				{
					deltaY1 = (nstep - (ciclo2 - 1)) * DimYFoto / nstep; 
					deltaY2 = (nstep - ciclo2) * DimYFoto / nstep -1; 
				}
				else
				{
					deltaY1 = (ciclo2 - 1) * DimYFoto / nstep; 
					deltaY2 = (ciclo2) * DimYFoto / nstep -1; 
				}
				if (Margine) 
				{	
					deltaY2 = deltaY2 + 1;
				}
				selRegion = Array(Array(0,deltaY1),
										Array(0,deltaY2,),
										Array(DimXFoto,deltaY2),
										Array(DimXFoto,deltaY1),
										Array(0, deltaY1))
			}
			if (Tipologia==3) // spicchi
			{
				var punto1x=DimXFoto / 2;
				var punto1y=DimYFoto ;
				var raggio=DimXFoto;
				var angolodeg2=0;
				var angolodeg3=0;
				
				if (Specchio)
				{
					angolodeg2=180-180/nstep*(nstep - (ciclo2 - 1));
					angolodeg3=180-180/nstep*(nstep - ciclo2);
				}
				else
				{
					angolodeg2=180-180/nstep*(ciclo2-1);
					angolodeg3=180-180/nstep*(ciclo2);
				}
				var angolorad2=angolodeg2 * Math.PI / 180; //trasformo in radianti
				var coseno=Math.cos(angolorad2);
				var seno=Math.sin(angolorad2);
				var punto2x= punto1x + coseno * raggio;
				var punto2y= punto1y - seno * raggio;
				var angolorad3=angolodeg3 * Math.PI / 180; //trasformo in radianti
				coseno=Math.cos(angolorad3);
				seno=Math.sin(angolorad3);
				var punto3x= punto1x + coseno * raggio;
				var punto3y= punto1y - seno * raggio;
				selRegion = Array(Array(punto1x,punto1y),
										Array(punto2x,punto2y),
										Array(punto3x,punto3y),
										Array(punto1x,punto1y))
			}
			if (Tipologia==4) // ventaglio
			{
				var centrox=DimXFoto / 2;
				var centroy=DimYFoto * 2;
				var raggio=DimXFoto * 2;
				var angolodeg1=0;
				var angolodeg3=0;
				if (Specchio)
				{
					angolodeg1=135-90/nstep*(nstep - (ciclo2 - 1));
					angolodeg3=135-90/nstep*(nstep - ciclo2);
				}
				else
				{
					angolodeg1=135-90/nstep*(ciclo2-1);
					angolodeg3=135-90/nstep*(ciclo2);
				}
				var angolorad1=angolodeg1 * Math.PI / 180; //trasformo in radianti
				var coseno=Math.cos(angolorad1);
				var seno=Math.sin(angolorad1);
				var punto1x= centrox + coseno * raggio/4;
				var punto1y= centroy - seno * raggio/4;
				var punto2x= centrox + coseno * raggio;
				var punto2y= centroy - seno * raggio;
				var angolorad3=angolodeg3 * Math.PI / 180; //trasformo in radianti
				coseno=Math.cos(angolorad3);
				seno=Math.sin(angolorad3);
				var punto3x= centrox + coseno * raggio;
				var punto3y= centroy - seno * raggio;
				var punto4x= centrox + coseno * raggio/4;
				var punto4y= centroy - seno * raggio/4;
				selRegion = Array(Array(punto1x,punto1y),
										Array(punto2x,punto2y),
										Array(punto3x,punto3y),
										Array(punto4x,punto4y),
										Array(punto1x,punto1y))
			}
			//faccio il copy e paste
			AD.selection.select(selRegion, SelectionType.REPLACE, 0)

			if (Tipologia==5)
			{
				var nstep2 = Math.floor(nstep) + 1 ;
				var dimslice = DimXFoto / nstep2;
				var deltax = dimslice * ciclo2;
				center	= true;
				border	= false;	
				shape	= ellipse;		
				type	= replace;
				feather	= 0;
				antiAlias	= false;
				setMarqueeSelection(deltax,	-DimYFoto, DimXFoto+deltax,	DimYFoto * 2, type, shape, feather, antiAlias);
				
			}	
			if (Tipologia==6)
			{
				var nstep2 = Math.floor(nstep) + 1 ;
				var dimslice = DimYFoto / nstep2;
				var deltax = dimslice * ciclo2;
				center	= true;
				border	= false;	
				shape	= ellipse;		
				type	= replace;
				feather	= 0;
				antiAlias	= false;
				setMarqueeSelection(-DimXFoto,	deltax, DimXFoto * 2, DimYFoto+deltax, type, shape, feather, antiAlias);
				
			}	
			if (Tipologia==7)
			{
				var centrox=DimXFoto/2;
				var nstep2 = Math.floor(nstep) + 1 ;
				var dimslice = DimXFoto / nstep2;
				var deltax = (dimslice * (nstep - (ciclo2-1))) / 2;
				center	= true;
				border	= false;	
				shape	= ellipse;		
				type	= replace;
				feather	= 0;
				antiAlias	= false;
				setMarqueeSelection(centrox - deltax,	-DimYFoto, centrox+deltax,	DimYFoto * 2, type, shape, feather, antiAlias);
				
			}	
			if (Tipologia==8)
			{
				var centrox=DimYFoto/2;
				var nstep2 = Math.floor(nstep) + 1 ;
				var dimslice = DimYFoto / nstep2;
				var deltax = (dimslice * (nstep - (ciclo2-1))) / 2;
				center	= true;
				border	= false;	
				shape	= ellipse;		
				type	= replace;
				feather	= 0;
				antiAlias	= false;
				setMarqueeSelection(-DimXFoto,centrox - deltax,	DimXFoto*2, centrox+deltax, type, shape, feather, antiAlias);
			}	
			
			AD.selection.copy();
			AD.close(SaveOptions.DONOTSAVECHANGES);
			
			
			
			
			
			
			
			
			
			
			
			
			
			if (Risultato==3 && ciclo2>ciclo1)
			{
			}
			else
			{
			
				try { 
						//faccio il paste nella stessa posizione
						var idpast = charIDToTypeID( "past" );
						var desc557 = new ActionDescriptor();
						var idinPlace = stringIDToTypeID( "inPlace" );
						desc557.putBoolean( idinPlace, true );
						var idAntA = charIDToTypeID( "AntA" );
						var idAnnt = charIDToTypeID( "Annt" );
						var idAnno = charIDToTypeID( "Anno" );
						desc557.putEnumerated( idAntA, idAnnt, idAnno );
						executeAction( idpast, desc557, DialogModes.NO );
						//fine faccio il paste nella stessa posizione
					}
					catch(err) {
					
								alert(ciclo1);
								alert(ciclo2);
								alert(err);
					}			
			
			}
			//createText("Arial-BoldMT", 24, 255,255,255, nfoto, deltaX1+20, 50);
			salva=false;
			if (ciclo2== nstep) 
			{
				salva=true;
				Continua2 = false;
			}
			if (salva) 
			{
				FotoElaborata = DirectoryFotoElaborate + "\\" + RadiceNome 
				if (ciclo1<10) FotoElaborata = FotoElaborata + "0"; 
				if (ciclo1<100) FotoElaborata = FotoElaborata + "0"; 
				FotoElaborata = FotoElaborata + numeroframe + "." + Estensione; 
				numeroframe = numeroframe + 1;
				var saveFile = File(FotoElaborata)
				if (Risultato!=3)
				{
					SaveJPEG(saveFile, QualitaJpeg);
				}
				else
				{
					SavePNG(saveFile);
					if (ciclo1<nstep)
					{
						for (i=0;i<4;i++)
						{
							FotoElaborata = DirectoryFotoElaborate + "\\" + RadiceNome 
							if (ciclo1<10) FotoElaborata = FotoElaborata + "0"; 
							if (ciclo1<100) FotoElaborata = FotoElaborata + "0"; 
							FotoElaborata = FotoElaborata + numeroframe + "." + Estensione; 
							numeroframe = numeroframe + 1;
							saveFile = File(FotoElaborata)
							SavePNG(saveFile);
						}
					}
				}
				if (Risultato!=1)
				{
					AD = activeDocument;
					AD.close(SaveOptions.DONOTSAVECHANGES);
				}
				else
				{
					Continua=false;
				}
			}
		}
		
	}
}
	  
	  
	  
	  
	  


	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  


	
}   

function createText(fface, size, colR, colG, colB, content, tX, tY)
{
  // Add a new layer in the new document
  var artLayerRef = app.activeDocument.artLayers.add()

  // Specify that the layer is a text layer
  artLayerRef.kind = LayerKind.TEXT

  //This section defines the color of the hello world text
  textColor = new SolidColor();
  textColor.rgb.red = colR;
  textColor.rgb.green = colG;
  textColor.rgb.blue = colB;

  //Get a reference to the text item so that we can add the text and format it a bit
  textItemRef = artLayerRef.textItem
  textItemRef.font = fface;
  textItemRef.contents = content;
  textItemRef.color = textColor;
  textItemRef.size = size
  textItemRef.position = new Array(tX, tY) //pixels from the left, pixels from the top
}




function cTID(s) { return app.charIDToTypeID(s); };
function sTID(s) { return app.stringIDToTypeID(s); };

function zeroPad(n, s) { 
n = n.toString(); 
while (n.length < s) n = '0' + n; 
return n; 
};

function SaveJPEG(saveFile, jpegQuality){
var doc = activeDocument;
if (doc.bitsPerChannel != BitsPerChannelType.EIGHT) doc.bitsPerChannel = BitsPerChannelType.EIGHT;
jpgSaveOptions = new JPEGSaveOptions();
jpgSaveOptions.embedColorProfile = true;
jpgSaveOptions.formatOptions = FormatOptions.STANDARDBASELINE;
jpgSaveOptions.matte = MatteType.NONE;
jpgSaveOptions.quality = jpegQuality; 
activeDocument.saveAs(saveFile, jpgSaveOptions, true,Extension.LOWERCASE);
}   

function SavePNG(saveFile){
pngSaveOptions = new PNGSaveOptions(); 
activeDocument.saveAs(saveFile, pngSaveOptions, true, Extension.LOWERCASE); 
}   


function checkInitialConditions() {
	// check if Background layer is selected
	if (activeDocument.activeLayer.isBackgroundLayer) {
		alert('The Background layer cannot be centered.\nPlease select another layer and try again.');
		return false; // quit
	}
	// check to see if the current layer contains any artwork
	else if (activeDocument.activeLayer.bounds[0] == activeDocument.activeLayer.bounds[2]) {
		alert('The current layer contains no artwork.\nPlease select another layer and try again.');
		return false; // quit
	}
	// check to see if a group is currently selected
	else if (activeDocument.activeLayer.typename == "LayerSet" && !confirm('Are you sure you want to center the entire group?')) {
		return false; // quit
	}
	// if all above conditions are met, proceed with main function
	else {
		return true; // continue
	}
}





/* ==================================================================================================================================================
================================================================================================================================================== */
function ARselect(width, height, center, border, shape,	type, feather, antiAlias ) {

	// prepare the ruler
	var defaultRulerUnits =	app.preferences.rulerUnits;
	app.preferences.rulerUnits = Units.PIXELS;

	var originalheight = app.activeDocument.height.value;
	var originalwidth =  app.activeDocument.width.value;

	// ====================================================================================================== //
	// Calculate Top Left Corner x1 y1 Bottom Left Corner x2 y2 for aspectratio + origin for avtive document  //
	// ====================================================================================================== //

	if ( height>width ) { aspectRatio = height/width;
	} else {aspectRatio = width/height;}

	if (originalheight>originalwidth) {
		// Portraits
		originalAspectRatio = originalheight/originalwidth;

		if (originalAspectRatio	< aspectRatio) {
			// Current aspect ratio	less trim width
			x1 = 0;
			y1 = 0;
			x2 = Math.round(originalheight/aspectRatio);
			y2 = originalheight;
			if ( center ) {
				x1 = Math.round(originalwidth-x2)/2;
				x2 += Math.round(originalwidth-x2)/2;
			}
		} else {
			// Current aspect not less trim	height
			x1 = 0;
			y1 = 0;
			x2 = originalwidth;
			y2= Math.round(originalwidth*aspectRatio);
			if ( center ) {
				y1 = Math.round(originalheight-y2)/2;
				y2 += Math.round(originalheight-y2)/2;
			}
		}
	} else {
		// Landscapes including	square
		originalAspectRatio = originalwidth/originalheight	
	
		if (originalAspectRatio	< aspectRatio) {
			// Current aspect ratio	less trim height
			x1 = 0;
			y1 = 0;
			x2 = originalwidth;
			y2 = Math.round(originalwidth /	aspectRatio);
			if ( center ) {
				y1 = Math.round(originalheight-y2)/2;
				y2 += Math.round(originalheight-y2)/2;
			}
		} else {
			// Current aspect not less trim	width
			x1 = 0;
			y1 = 0;
			x2= Math.round(originalheight*aspectRatio);
			y2 = originalheight;
			if ( center )	{
				x1 = Math.round(originalwidth-x2)/2;
				x2 += Math.round(originalwidth-x2)/2;
			}
		}
	}
	if (border) {
		xBorder	= Math.round(x2-x1)*.25/2;
		yBorder	= Math.round(y2-y1)*.25/2;
		x1 = x1+xBorder;
		x2 = x2-xBorder;
		y1 = y1+yBorder;
		y2 = y2-yBorder;
	}

	// Set Marquee Selection Top Left and Bottom Right corners (x1,	y1, x2,	y2);
	setMarqueeSelection(x1,	y1, x2,	y2, type, shape, feather, antiAlias);

	// restore the ruler to	whatever unit it was in
	app.preferences.rulerUnits = defaultRulerUnits;

	isCancelled = false; //	if get here, definitely	executed
	return false; // no error
}

/* SetMarqueeSelection function from Scriptlistner plugin
// ========================================================================== */
function setMarqueeSelection(x1, y1, x2, y2, type, shape, feather, antiAlias) {

	var SelectionType =null;
	if (type ==null)      {	var SelectionType = "setd" }
 	if (type =="diminish")  {	var SelectionType = "SbtF" }
	if (type =="extend")    {	var SelectionType = "AddT" }
	if (type =="intersect") {	var SelectionType = "IntW" }
	if (type =="replace")   {	var SelectionType = "setd" }

	var id3	= charIDToTypeID( SelectionType	);
	    var	desc2 =	new ActionDescriptor();
	    var	id4 = charIDToTypeID( "null" );
		var ref1 = new ActionReference();
		var id5	= charIDToTypeID( "Chnl" );
		var id6	= charIDToTypeID( "fsel" );
		ref1.putProperty( id5, id6 );
	    desc2.putReference(	id4, ref1 );
	    var	id7 = charIDToTypeID( "T   " );
		var desc3 = new	ActionDescriptor();
		var id8	= charIDToTypeID( "Top " );
		var id9	= charIDToTypeID( "#Pxl" );
		desc3.putUnitDouble( id8, id9, y1 );
		var id10 = charIDToTypeID( "Left" );
		var id11 = charIDToTypeID( "#Pxl" );
		desc3.putUnitDouble( id10, id11, x1 );
		var id12 = charIDToTypeID( "Btom" );
		var id13 = charIDToTypeID( "#Pxl" );
		desc3.putUnitDouble( id12, id13, y2 );
		var id14 = charIDToTypeID( "Rght" );
		var id15 = charIDToTypeID( "#Pxl" );
		desc3.putUnitDouble( id14, id15, x2 );
	    var	id16 = charIDToTypeID( shape );
	    desc2.putObject( id7, id16,	desc3 );
	    var	id17 = charIDToTypeID( "Fthr" );
	    var	id18 = charIDToTypeID( "#Pxl" );
	    desc2.putUnitDouble( id17, id18, feather );
	    var	id19 = charIDToTypeID( "AntA" );
	    desc2.putBoolean( id19, antiAlias );
	executeAction( id3, desc2, DialogModes.NO );
}



